﻿Type=StaticCode
Version=2
ModulesStructureVersion=1
B4R=true
@EndOfDesignText@


Sub Process_Globals
	Private buffer(300) As Byte	
	Private length As UInt
	Private bc As ByteConverter
	Public LastItem() As Byte
	Private numberOfItems As UInt
End Sub

'Adds the data to the top of the stack
Public Sub Push(b() As Byte)
	If length + b.Length > buffer.Length Then
		Log("Buffer overflow! Increase the buffer size in the Stack module")
		Return
	End If
	bc.ArrayCopy2(b, 0, buffer, length , b.Length)
	buffer(length + b.Length) = b.Length
	length = length + b.Length + 1
	numberOfItems = numberOfItems + 1
	UpdateLastItem
End Sub

'Removes the top item from the stack
Public Sub Pop
	If numberOfItems = 0 Then
		Log("Buffer underflow!")
		Return
	End If
	length = length - buffer(length - 1) - 1
	numberOfItems = numberOfItems - 1
	If numberOfItems > 0 Then UpdateLastItem
End Sub

Public Sub Size As UInt
	Return numberOfItems
End Sub

Private Sub UpdateLastItem 
	RunNative("UpdateLastItem", Null)
End Sub

#if C
void UpdateLastItem(B4R::Object* o) {
	b4r_stack::_lastitem->length = ByteFromArray(b4r_stack::_buffer,  b4r_stack::_length-1);
	b4r_stack::_lastitem->data = (Byte*)b4r_stack::_buffer->data + b4r_stack::_length-1 - b4r_stack::_lastitem->length;
}

#End If